#include "Men.h"
#include "Initialisierung.h"
#include <MausEreignis.h>
#include <Textfeld.h>
#include <InitDatei.h>
#include <Text.h>
#include <Datei.h>
#include <TastaturEreignis.h>
#include <KSGTDatei.h>
#include <Schrift.h>
#include <DateiSystem.h>
#include <Rahmen.h>
#include <AsynchronCall.h>
#include <Bildschirm.h>

// Inhalt der Men Klasse aus Men.h
// Konstruktor
Men::Men( Schrift *zSchrift, Bildschirm *zScreen, KSGClient::MinigameServerClient *klient )
{
	spielen = initKnopf( 350, 180, 100, 20, zSchrift, Knopf::Style::Sichtbar, "Spielen" );
	optionen = initKnopf( 350, 220, 100, 20, zSchrift, Knopf::Style::Sichtbar, "Optionen" );
	statistik = initKnopf( 350, 260, 100, 20, zSchrift, Knopf::Style::Sichtbar, "Statistik" );
	beenden = initKnopf( 350, 300, 100, 20, zSchrift, Knopf::Style::Sichtbar, "Beenden" );
	ram = new LRahmen();
	ram->setFarbe( 0xFFFFFFFF );
	beendet = 0;
	status = 0;
	LTDBDatei *bgd = new LTDBDatei();
	bgd->setDatei( new Text( "data/Minigames/Fangen/bilder/hintergrund.ltdb" ) );
	bgd->leseDaten( 0 );
	hintergrund = bgd->laden( 0, new Text( "bg.jpg" ) );
	bgd->release();
	ref = 1;
}

// Destruktor
Men::~Men()
{
	spielen->release();
	optionen->release();
	statistik->release();
	beenden->release();
	if( hintergrund )
		hintergrund->release();
	ram->release();
}

// nicht constant
void Men::reset()
{
	status = 0;
	beendet = 0;
}

void Men::doMausEreignis( MausEreignis &me )
{
	switch( status )
	{
	case 0:
		if( 1 )
		{
			bool vera = me.verarbeitet;
			spielen->doMausEreignis( me );
			if( !vera && me.verarbeitet && me.id == ME_RLinks )
			{
                // spielen aufrufen
				status = 3;
			}
			vera = me.verarbeitet;
			optionen->doMausEreignis( me );
			if( !vera && me.verarbeitet && me.id == ME_RLinks )
			{
                // optionen aufrufen
				status = 1;
			}
			vera = me.verarbeitet;
			statistik->doMausEreignis( me );
			if( !vera && me.verarbeitet && me.id == ME_RLinks )
			{
                // statistik aufrufen
				status = 2;
			}
			vera = me.verarbeitet;
			beenden->doMausEreignis( me );
			if( !vera && me.verarbeitet && me.id == ME_RLinks )
				beendet = 1;
		}
		break;
	case 1:
        // optionen me
		break;
	case 2:
        // statistik me
		break;
	case 3:
        // spielen me
	}
}

void Men::doTastaturEreignis( TastaturEreignis &te )
{
	//if( status == 1 )
        // optionen te
	//if( status == 3 )
        // spielen te
}

bool Men::tick( double z )
{
	switch( status )
	{
	case 0:
		if( 1 )
		{
			bool ret = spielen->tick( z );
			ret |= statistik->tick( z );
			ret |= optionen->tick( z );
			ret |= beenden->tick( z );
			return ret;
		}
	case 1:/*
		if( optionenF->istBeendet() )
		{
			status = 0;
			return 1;
		}
		return optionenF->tick( z );
	case 2:
		if( statistikF->istBeendet() )
		{
			status = 0;
			return 1;
		}
		return statistikF->tick( z );
	case 3:
		if( spielenF->istBeendet() )
		{
			status = 0;
			return 1;
		}
		return spielenF->tick( z );*/
	}
	return 0;
}

void Men::render( Bild &zRObj )
{
	if( status != 3 && hintergrund && ( status != 2 /*|| !statistikF->istWiederhohlung()*/ ) )
		zRObj.drawBild( 0, 0, hintergrund->getBreite(), hintergrund->getHeight(), *hintergrund );
	switch( status )
	{
	case 0:
		ram->setPosition( 300, 170 );
		ram->setSize( 200, 160 );
		zRObj.alphaRegion( ram->getX(), ram->getY(), ram->getBreite(), ram->getHeight(), 0xD0000000 );
		ram->render( zRObj );
		spielen->render( zRObj );
		statistik->render( zRObj );
		optionen->render( zRObj );
		beenden->render( zRObj );
		break;
	case 1:
		ram->setPosition( 300, 110 );
		ram->setSize( 200, 280 );
		zRObj.alphaRegion( ram->getX(), ram->getY(), ram->getBreite(), ram->getHeight(), 0xD0000000 );
		ram->render( zRObj );
		//optionenF->render( zRObj );
		break;
	case 2:
		if( hintergrund /*&& !statistikF->istWiederhohlung()*/ )
			zRObj.alphaRegion( 0, 0, hintergrund->getBreite(), hintergrund->getHeight(), 0xD0000000 );
		//statistikF->render( zRObj );
		break;
	case 3:
		//spielenF->render( zRObj );
	}
}

// constant
bool Men::istBeendet() const
{
	return beendet;
}

// Reference Counting
Men *Men::getThis()
{
	ref++;
	return this;
}

Men *Men::release()
{
	ref--;
	if( !ref )
		delete this;
	return 0;
}